#include <string>
#include <vector>

namespace Xml { class Xml::XmlNode; }

namespace AJP13 {

/** http://www.alhem.net/1.0/server */
namespace net_alhem_1_0_server {

	// -----------------------------------------------------------------------------
	class Security
	{
	// internal complexType: group_t
	public:
		// parent: security
		class Group_t
		{
		public:
			Group_t();
			Group_t(const Xml::XmlNode& it);
			virtual ~Group_t() {}

			void FromXml(const Xml::XmlNode& it);

			const std::string ToString(const std::string& name) const;

			bool IsSet() const;

			const std::string& AttrGetName() const;
			void AttrSetName(const std::string& name);

			bool AttrNameIsSet() const { return _attribute_name_is_set; }

		private:
			std::string _attribute_name;
			bool _attribute_name_is_set;
		};

	// internal complexType: basicAuthentication_t
	public:
		// parent: security
		class BasicAuthentication_t
		{
		// internal complexType: user_t
		public:
			// parent: basicAuthentication_t
			class User_t
			{
			public:
				User_t();
				User_t(const Xml::XmlNode& it);
				virtual ~User_t() {}

				void FromXml(const Xml::XmlNode& it);

				const std::string ToString(const std::string& name) const;

				bool IsSet() const;

				const std::string& AttrGetLogin() const;
				void AttrSetLogin(const std::string& login);
				const std::string& AttrGetAuth() const;
				void AttrSetAuth(const std::string& auth);
				const std::string& AttrGetName() const;
				void AttrSetName(const std::string& name);
				const std::string& AttrGetGroups() const;
				void AttrSetGroups(const std::string& groups);

				bool AttrLoginIsSet() const { return _attribute_login_is_set; }
				bool AttrAuthIsSet() const { return _attribute_auth_is_set; }
				bool AttrNameIsSet() const { return _attribute_name_is_set; }
				bool AttrGroupsIsSet() const { return _attribute_groups_is_set; }

			private:
				std::string _attribute_login;
				std::string _attribute_auth;
				std::string _attribute_name;
				std::string _attribute_groups;
				bool _attribute_login_is_set;
				bool _attribute_auth_is_set;
				bool _attribute_name_is_set;
				bool _attribute_groups_is_set;
			};

		public:
			BasicAuthentication_t();
			BasicAuthentication_t(const Xml::XmlNode& it);
			virtual ~BasicAuthentication_t() {}

			void FromXml(const Xml::XmlNode& it);

			const std::string ToString(const std::string& name) const;

			bool IsSet() const;

			const net_alhem_1_0_server::Security::BasicAuthentication_t::User_t& GetUser() const;
			net_alhem_1_0_server::Security::BasicAuthentication_t::User_t& GetUser();
			void SetUser(const net_alhem_1_0_server::Security::BasicAuthentication_t::User_t& user);

			const std::string& AttrGetName() const;
			void AttrSetName(const std::string& name);

			bool UserIsSet() const;

			bool AttrNameIsSet() const { return _attribute_name_is_set; }

		private:
			net_alhem_1_0_server::Security::BasicAuthentication_t::User_t _element_user;
			std::string _attribute_name;
			bool _attribute_name_is_set;
		};

	// internal complexType: authorization_t
	public:
		// parent: security
		class Authorization_t
		{
		public:
			Authorization_t();
			Authorization_t(const Xml::XmlNode& it);
			virtual ~Authorization_t() {}

			void FromXml(const Xml::XmlNode& it);

			const std::string ToString(const std::string& name) const;

			bool IsSet() const;

			const std::vector<std::string>& GetGroup() const;
			std::vector<std::string>& GetGroup();
			void SetGroup(const std::vector<std::string>& group);

			const std::vector<std::string>& GetUser() const;
			std::vector<std::string>& GetUser();
			void SetUser(const std::vector<std::string>& user);

			const std::string& AttrGetName() const;
			void AttrSetName(const std::string& name);
			const std::string& AttrGetLevel() const;
			void AttrSetLevel(const std::string& level);

			bool GroupIsSet() const;
			bool UserIsSet() const;

			bool AttrNameIsSet() const { return _attribute_name_is_set; }
			bool AttrLevelIsSet() const { return _attribute_level_is_set; }

		private:
			std::vector<std::string> _element_group;
			std::vector<std::string> _element_user;
			std::string _attribute_name;
			std::string _attribute_level;
			bool _attribute_name_is_set;
			bool _attribute_level_is_set;
		};

	public:
		Security();
		Security(const Xml::XmlNode& it);
		virtual ~Security() {}

		void FromXml(const Xml::XmlNode& it);

		const std::string ToString(const std::string& name) const;

		bool IsSet() const;

		const std::vector<net_alhem_1_0_server::Security::Group_t>& GetGroup() const;
		std::vector<net_alhem_1_0_server::Security::Group_t>& GetGroup();
		void SetGroup(const std::vector<net_alhem_1_0_server::Security::Group_t>& group);

		const net_alhem_1_0_server::Security::BasicAuthentication_t& GetBasicAuthentication() const;
		net_alhem_1_0_server::Security::BasicAuthentication_t& GetBasicAuthentication();
		void SetBasicAuthentication(const net_alhem_1_0_server::Security::BasicAuthentication_t& basicAuthentication);

		const net_alhem_1_0_server::Security::Authorization_t& GetAuthorization() const;
		net_alhem_1_0_server::Security::Authorization_t& GetAuthorization();
		void SetAuthorization(const net_alhem_1_0_server::Security::Authorization_t& authorization);

		bool GroupIsSet() const;
		bool BasicAuthenticationIsSet() const;
		bool AuthorizationIsSet() const;

	private:
		std::vector<net_alhem_1_0_server::Security::Group_t> _element_group;
		net_alhem_1_0_server::Security::BasicAuthentication_t _element_basicAuthentication;
		net_alhem_1_0_server::Security::Authorization_t _element_authorization;
	};

	// -----------------------------------------------------------------------------
	class Log
	{
	public:
		Log();
		Log(const Xml::XmlNode& it);
		virtual ~Log() {}

		void FromXml(const Xml::XmlNode& it);

		const std::string ToString(const std::string& name) const;

		bool IsSet() const;

		const std::string& AttrGetFilename() const;
		void AttrSetFilename(const std::string& filename);
		const std::string& AttrGetType() const;
		void AttrSetType(const std::string& type);
		const std::string& AttrGetFormat() const;
		void AttrSetFormat(const std::string& format);

		bool AttrFilenameIsSet() const { return _attribute_filename_is_set; }
		bool AttrTypeIsSet() const { return _attribute_type_is_set; }
		bool AttrFormatIsSet() const { return _attribute_format_is_set; }

	private:
		std::string _attribute_filename;
		std::string _attribute_type;
		std::string _attribute_format;
		bool _attribute_filename_is_set;
		bool _attribute_type_is_set;
		bool _attribute_format_is_set;
	};

	// -----------------------------------------------------------------------------
	class Hosts
	{
	// internal complexType: hostDefaults_t
	public:
		// parent: hosts
		class HostDefaults_t
		{
		public:
			HostDefaults_t();
			HostDefaults_t(const Xml::XmlNode& it);
			virtual ~HostDefaults_t() {}

			void FromXml(const Xml::XmlNode& it);

			const std::string ToString(const std::string& name) const;

			bool IsSet() const;

			const std::string& GetDocuments() const;
			void SetDocuments(const std::string& documents);

			const std::string& GetScripts() const;
			void SetScripts(const std::string& scripts);

			const std::string& GetLogs() const;
			void SetLogs(const std::string& logs);

			const std::string& GetIndexDocument() const;
			void SetIndexDocument(const std::string& indexDocument);

			const std::vector<net_alhem_1_0_server::Log>& GetLog() const;
			std::vector<net_alhem_1_0_server::Log>& GetLog();
			void SetLog(const std::vector<net_alhem_1_0_server::Log>& log);

			bool DocumentsIsSet() const { return _element_documents_is_set; }
			bool ScriptsIsSet() const { return _element_scripts_is_set; }
			bool LogsIsSet() const { return _element_logs_is_set; }
			bool IndexDocumentIsSet() const { return _element_indexDocument_is_set; }
			bool LogIsSet() const;

		private:
			std::string _element_documents;
			std::string _element_scripts;
			std::string _element_logs;
			std::string _element_indexDocument;
			std::vector<net_alhem_1_0_server::Log> _element_log;
			bool _element_documents_is_set;
			bool _element_scripts_is_set;
			bool _element_logs_is_set;
			bool _element_indexDocument_is_set;
		};

	// internal complexType: host_t
	public:
		// parent: hosts
		class Host_t
		{
		// internal complexType: alias_t
		public:
			// parent: host_t
			class Alias_t
			{
			public:
				Alias_t();
				Alias_t(const Xml::XmlNode& it);
				virtual ~Alias_t() {}

				void FromXml(const Xml::XmlNode& it);

				const std::string ToString(const std::string& name) const;

				bool IsSet() const;

				const std::string& AttrGetName() const;
				void AttrSetName(const std::string& name);
				const std::string& AttrGetRedirect() const;
				void AttrSetRedirect(const std::string& redirect);

				bool AttrNameIsSet() const { return _attribute_name_is_set; }
				bool AttrRedirectIsSet() const { return _attribute_redirect_is_set; }

			private:
				std::string _attribute_name;
				std::string _attribute_redirect;
				bool _attribute_name_is_set;
				bool _attribute_redirect_is_set;
			};

		// internal complexType: ssl_t
		public:
			// parent: host_t
			class Ssl_t
			{
			public:
				Ssl_t();
				Ssl_t(const Xml::XmlNode& it);
				virtual ~Ssl_t() {}

				void FromXml(const Xml::XmlNode& it);

				const std::string ToString(const std::string& name) const;

				bool IsSet() const;

				const std::string& GetCertFile() const;
				void SetCertFile(const std::string& certFile);

				const std::string& GetKeyFile() const;
				void SetKeyFile(const std::string& keyFile);

				const std::string& GetKeyAuth() const;
				void SetKeyAuth(const std::string& keyAuth);

				bool CertFileIsSet() const { return _element_certFile_is_set; }
				bool KeyFileIsSet() const { return _element_keyFile_is_set; }
				bool KeyAuthIsSet() const { return _element_keyAuth_is_set; }

			private:
				std::string _element_certFile;
				std::string _element_keyFile;
				std::string _element_keyAuth;
				bool _element_certFile_is_set;
				bool _element_keyFile_is_set;
				bool _element_keyAuth_is_set;
			};

		// internal complexType: mount_t
		public:
			// parent: host_t
			class Mount_t
			{
			public:
				Mount_t();
				Mount_t(const Xml::XmlNode& it);
				virtual ~Mount_t() {}

				void FromXml(const Xml::XmlNode& it);

				const std::string ToString(const std::string& name) const;

				bool IsSet() const;

				const std::string& AttrGetUri() const;
				void AttrSetUri(const std::string& uri);
				const std::string& AttrGetJobber() const;
				void AttrSetJobber(const std::string& jobber);
				const std::string& AttrGetStrip() const;
				void AttrSetStrip(const std::string& strip);
				const std::string& AttrGetPath() const;
				void AttrSetPath(const std::string& path);

				bool AttrUriIsSet() const { return _attribute_uri_is_set; }
				bool AttrJobberIsSet() const { return _attribute_jobber_is_set; }
				bool AttrStripIsSet() const { return _attribute_strip_is_set; }
				bool AttrPathIsSet() const { return _attribute_path_is_set; }

			private:
				std::string _attribute_uri;
				std::string _attribute_jobber;
				std::string _attribute_strip;
				std::string _attribute_path;
				bool _attribute_uri_is_set;
				bool _attribute_jobber_is_set;
				bool _attribute_strip_is_set;
				bool _attribute_path_is_set;
			};

		// internal complexType: secure_t
		public:
			// parent: host_t
			class Secure_t
			{
			public:
				Secure_t();
				Secure_t(const Xml::XmlNode& it);
				virtual ~Secure_t() {}

				void FromXml(const Xml::XmlNode& it);

				const std::string ToString(const std::string& name) const;

				bool IsSet() const;

				const std::string& AttrGetUri() const;
				void AttrSetUri(const std::string& uri);
				const std::string& AttrGetBasicAuthentication() const;
				void AttrSetBasicAuthentication(const std::string& basicAuthentication);
				const std::string& AttrGetAuthorization() const;
				void AttrSetAuthorization(const std::string& authorization);

				bool AttrUriIsSet() const { return _attribute_uri_is_set; }
				bool AttrBasicAuthenticationIsSet() const { return _attribute_basicAuthentication_is_set; }
				bool AttrAuthorizationIsSet() const { return _attribute_authorization_is_set; }

			private:
				std::string _attribute_uri;
				std::string _attribute_basicAuthentication;
				std::string _attribute_authorization;
				bool _attribute_uri_is_set;
				bool _attribute_basicAuthentication_is_set;
				bool _attribute_authorization_is_set;
			};

		public:
			Host_t();
			Host_t(const Xml::XmlNode& it);
			virtual ~Host_t() {}

			void FromXml(const Xml::XmlNode& it);

			const std::string ToString(const std::string& name) const;

			bool IsSet() const;

			const std::string& GetDocuments() const;
			void SetDocuments(const std::string& documents);

			const std::string& GetScripts() const;
			void SetScripts(const std::string& scripts);

			const std::string& GetLogs() const;
			void SetLogs(const std::string& logs);

			const std::string& GetIndexDocument() const;
			void SetIndexDocument(const std::string& indexDocument);

			const std::vector<net_alhem_1_0_server::Log>& GetLog() const;
			std::vector<net_alhem_1_0_server::Log>& GetLog();
			void SetLog(const std::vector<net_alhem_1_0_server::Log>& log);

			const net_alhem_1_0_server::Hosts::Host_t::Alias_t& GetAlias() const;
			net_alhem_1_0_server::Hosts::Host_t::Alias_t& GetAlias();
			void SetAlias(const net_alhem_1_0_server::Hosts::Host_t::Alias_t& alias);

			const net_alhem_1_0_server::Hosts::Host_t::Ssl_t& GetSsl() const;
			net_alhem_1_0_server::Hosts::Host_t::Ssl_t& GetSsl();
			void SetSsl(const net_alhem_1_0_server::Hosts::Host_t::Ssl_t& ssl);

			const std::string& GetPre() const;
			void SetPre(const std::string& pre);

			const std::vector<net_alhem_1_0_server::Hosts::Host_t::Mount_t>& GetMount() const;
			std::vector<net_alhem_1_0_server::Hosts::Host_t::Mount_t>& GetMount();
			void SetMount(const std::vector<net_alhem_1_0_server::Hosts::Host_t::Mount_t>& mount);

			const std::vector<net_alhem_1_0_server::Hosts::Host_t::Secure_t>& GetSecure() const;
			std::vector<net_alhem_1_0_server::Hosts::Host_t::Secure_t>& GetSecure();
			void SetSecure(const std::vector<net_alhem_1_0_server::Hosts::Host_t::Secure_t>& secure);

			const std::string& AttrGetName() const;
			void AttrSetName(const std::string& name);
			const std::string& AttrGetRootDir() const;
			void AttrSetRootDir(const std::string& rootDir);

			bool DocumentsIsSet() const { return _element_documents_is_set; }
			bool ScriptsIsSet() const { return _element_scripts_is_set; }
			bool LogsIsSet() const { return _element_logs_is_set; }
			bool IndexDocumentIsSet() const { return _element_indexDocument_is_set; }
			bool LogIsSet() const;
			bool AliasIsSet() const;
			bool SslIsSet() const;
			bool PreIsSet() const { return _element_pre_is_set; }
			bool MountIsSet() const;
			bool SecureIsSet() const;

			bool AttrNameIsSet() const { return _attribute_name_is_set; }
			bool AttrRootDirIsSet() const { return _attribute_rootDir_is_set; }

		private:
			std::string _element_documents;
			std::string _element_scripts;
			std::string _element_logs;
			std::string _element_indexDocument;
			std::vector<net_alhem_1_0_server::Log> _element_log;
			net_alhem_1_0_server::Hosts::Host_t::Alias_t _element_alias;
			net_alhem_1_0_server::Hosts::Host_t::Ssl_t _element_ssl;
			std::string _element_pre;
			std::vector<net_alhem_1_0_server::Hosts::Host_t::Mount_t> _element_mount;
			std::vector<net_alhem_1_0_server::Hosts::Host_t::Secure_t> _element_secure;
			std::string _attribute_name;
			std::string _attribute_rootDir;
			bool _element_documents_is_set;
			bool _element_scripts_is_set;
			bool _element_logs_is_set;
			bool _element_indexDocument_is_set;
			bool _element_pre_is_set;
			bool _attribute_name_is_set;
			bool _attribute_rootDir_is_set;
		};

	public:
		Hosts();
		Hosts(const Xml::XmlNode& it);
		virtual ~Hosts() {}

		void FromXml(const Xml::XmlNode& it);

		const std::string ToString(const std::string& name) const;

		bool IsSet() const;

		const net_alhem_1_0_server::Hosts::HostDefaults_t& GetHostDefaults() const;
		net_alhem_1_0_server::Hosts::HostDefaults_t& GetHostDefaults();
		void SetHostDefaults(const net_alhem_1_0_server::Hosts::HostDefaults_t& hostDefaults);

		const std::vector<net_alhem_1_0_server::Hosts::Host_t>& GetHost() const;
		std::vector<net_alhem_1_0_server::Hosts::Host_t>& GetHost();
		void SetHost(const std::vector<net_alhem_1_0_server::Hosts::Host_t>& host);

		bool HostDefaultsIsSet() const;
		bool HostIsSet() const;

	private:
		net_alhem_1_0_server::Hosts::HostDefaults_t _element_hostDefaults;
		std::vector<net_alhem_1_0_server::Hosts::Host_t> _element_host;
	};

	// -----------------------------------------------------------------------------
	class Network
	{
	// internal complexType: bind_t
	public:
		// parent: network
		class Bind_t
		{
		public:
			Bind_t();
			Bind_t(const Xml::XmlNode& it);
			virtual ~Bind_t() {}

			void FromXml(const Xml::XmlNode& it);

			const std::string ToString(const std::string& name) const;

			bool IsSet() const;

			const std::string& AttrGetInterface() const;
			void AttrSetInterface(const std::string& interface);
			int AttrGetPort() const;
			void AttrSetPort(int port);
			const std::string& AttrGetProtocol() const;
			void AttrSetProtocol(const std::string& protocol);
			const std::string& AttrGetHost() const;
			void AttrSetHost(const std::string& host);

			bool AttrInterfaceIsSet() const { return _attribute_interface_is_set; }
			bool AttrPortIsSet() const { return _attribute_port_is_set; }
			bool AttrProtocolIsSet() const { return _attribute_protocol_is_set; }
			bool AttrHostIsSet() const { return _attribute_host_is_set; }

		private:
			std::string _attribute_interface;
			int _attribute_port;
			std::string _attribute_protocol;
			std::string _attribute_host;
			bool _attribute_interface_is_set;
			bool _attribute_port_is_set;
			bool _attribute_protocol_is_set;
			bool _attribute_host_is_set;
		};

	public:
		Network();
		Network(const Xml::XmlNode& it);
		virtual ~Network() {}

		void FromXml(const Xml::XmlNode& it);

		const std::string ToString(const std::string& name) const;

		bool IsSet() const;

		const std::vector<net_alhem_1_0_server::Network::Bind_t>& GetBind() const;
		std::vector<net_alhem_1_0_server::Network::Bind_t>& GetBind();
		void SetBind(const std::vector<net_alhem_1_0_server::Network::Bind_t>& bind);

		bool BindIsSet() const;

	private:
		std::vector<net_alhem_1_0_server::Network::Bind_t> _element_bind;
	};

	// -----------------------------------------------------------------------------
	class Configuration_t
	{
	public:
		Configuration_t();
		Configuration_t(const Xml::XmlNode& it);
		virtual ~Configuration_t() {}

		void FromXml(const Xml::XmlNode& it);

		const std::string ToString(const std::string& name) const;

		bool IsSet() const;

		const std::string& GetRootDir() const;
		void SetRootDir(const std::string& rootDir);

		const net_alhem_1_0_server::Security& GetSecurity() const;
		net_alhem_1_0_server::Security& GetSecurity();
		void SetSecurity(const net_alhem_1_0_server::Security& security);

		const net_alhem_1_0_server::Hosts& GetHosts() const;
		net_alhem_1_0_server::Hosts& GetHosts();
		void SetHosts(const net_alhem_1_0_server::Hosts& hosts);

		const net_alhem_1_0_server::Network& GetNetwork() const;
		net_alhem_1_0_server::Network& GetNetwork();
		void SetNetwork(const net_alhem_1_0_server::Network& network);

		bool RootDirIsSet() const { return _element_rootDir_is_set; }
		bool SecurityIsSet() const;
		bool HostsIsSet() const;
		bool NetworkIsSet() const;

	private:
		std::string _element_rootDir;
		net_alhem_1_0_server::Security _element_security;
		net_alhem_1_0_server::Hosts _element_hosts;
		net_alhem_1_0_server::Network _element_network;
		bool _element_rootDir_is_set;
	};

} // namespace net_alhem_1_0_server



} // namespace AJP13

